//
//  CoreDataAdditions.m
//  CoreDataCooking
//

#import "CoreDataAdditions.h"


@implementation NSManagedObjectContext (CoreDataAdditions)

- (NSEntityDescription *)entityForName:(NSString *)aName
{
    return [NSEntityDescription entityForName:aName
                       inManagedObjectContext:self];
}

- (id)insertNewObjectForEntityForName:(NSString *)aName
{
    return [NSEntityDescription insertNewObjectForEntityForName:aName
                                         inManagedObjectContext:self];
}

- (NSFetchRequest *)fetchRequestWithEntityName:(NSString *)aName
{
    NSFetchRequest *request;
    NSEntityDescription *entity;
    
    entity = [NSEntityDescription entityForName:aName
                         inManagedObjectContext:self];
    request = [[[NSFetchRequest alloc] init] autorelease];
    [request setEntity:entity];
    
    return request;
}


- (NSArray *)fetchWithEntityName:(NSString *)aName
                           error:(NSError **)error
             predicateWithFormat:(NSString *)format, ...
{
    va_list argList;
    return [self fetchWithEntityName:aName
                               error:error
                 predicateWithFormat:format
                           arguments:argList];
}

- (NSArray *)fetchWithEntityName:(NSString *)aName
                           error:(NSError **)error
             predicateWithFormat:(NSString *)format
                       arguments:(va_list)argList
{
    NSFetchRequest *request;
    NSPredicate *pred;
    NSEntityDescription *entity;
    
    request = [self fetchRequestWithEntityName:aName];
    pred = [NSPredicate predicateWithFormat:format arguments:argList];
    entity = [self entityForName:aName];
    [request setPredicate:pred];
    [request setEntity:entity];
    
    return [self executeFetchRequest:request error:error];
}

@end
